#ifndef ASSISTANT_H
#define ASSISTANT_H

#include <iostream>
using namespace std;

class Assistant{
private:
	int age;
	static Assistant* instance;

	Assistant(){
		cout << "Assistant : implicit constructor ... "	<<endl;
		age = 0;
	}
	Assistant(int a) : age(a){
		cout << "Assistant : constructor with param... "	<<endl;
	}
	Assistant(const Assistant &a){
		cout << "Assistant : copy constructor ... "	<<endl;
		age = a.age;
	}
	Assistant& operator=(const Assistant &a){
		if (this != &a){
			this->age = a.age;
		}
		return *this;
	}
public:
	~Assistant(){
		cout << "Assistant : destructor ... "	<<endl;
	}
	static Assistant& getInstance(int a){
		if (!instance){
			cout << "Assistant : first assistant object ... " << endl;
			instance = new Assistant(a);
		}
		else
			cout << "Assistant : an instance to Assistant was already created ... " << endl;
		return *instance;
	}
	int getAge(){
		return age;
	}
};

Assistant* Assistant::instance = NULL;


#endif