#include "Doctor.h"

Doctor::Doctor(char*n, Repository<Patient>* r){
	name = new char[strlen(n) + 1];
	strcpy_s(name, strlen(n) + 1, n);
	patientRepo = r;
}

Doctor::Doctor(Doctor &d){
	setName(d.name);
	patientRepo = new Repository<Patient>(*d.patientRepo);
}
Doctor::~Doctor(){
	if (name){
		delete[] name;
		name = NULL;
	}
}
Doctor& Doctor::operator=(Doctor &d){
	setName(d.name);
	patientRepo = d.patientRepo;
	return *this;
}
void Doctor::setName(char* n){
	if (name)
		delete[] name;
	name = new char[strlen(n) + 1];
	strcpy_s(name, strlen(n) + 1, n);
}
void Doctor::addNewPatient(char* n, char* a){
	Patient p = Patient(n, a);
	patientRepo->addElem(p);
}

char* Doctor::sortPatientsByName(){
	Patient* all = patientRepo->getAll();
	for(int i = 0; i < patientRepo->getSize() - 1; i++)
		for(int j = i + 1; j < patientRepo->getSize(); j++)
			if (all[i] > all[j]){
				Patient aux = all[i];
				all[i] = all[j];
				all[j] = aux;
			}
	char* s = new char[10000];
	for(int i = 0; i < patientRepo->getSize(); i++){
		strcat_s(s, 10000, all[i].toString());
		strcat_s(s, 10000, "; ");
	}
	return s;
}

char* Doctor::getAllPatients(){
	Patient* all = patientRepo->getAll();
	char* s = new char[10000];
	strcpy_s(s, 10000, " ");
	for(int i = 0; i < patientRepo->getSize(); i++){
		strcat_s(s, 10000, all[i].toString());
		strcat_s(s, 10000, "; ");
	}
	return s;
}

char* Doctor::getName(){
	return name;
}