#include "FlowerFileRepository.h"
#include <QMainWindow>

FlowerFileRepository::FlowerFileRepository(char* fN){
    fileName = new char[strlen(fN) + 1];
    strcpy(fileName, fN);
    loadData();
}

void FlowerFileRepository::loadData(){
    ifstream fin;
    fin.open(fileName);
    if (!fin.fail()){
        while (!fin.eof()){
            char* s = new char[1000];
            fin >> s;
            Flower f(s);
            flowerList.push_back(f);
        }
        fin.close();
    }
}

void FlowerFileRepository::saveData(){
    ofstream fout;
    fout.open(fileName);
    list<Flower>::iterator it = flowerList.begin();
    while (it != flowerList.end()){
        fout << (*it).toString();
        it++;
        if (it != flowerList.end())
            fout << endl;
    }
    fout.close();
}

FlowerFileRepository::~FlowerFileRepository(){
    saveData();
}

list<Flower> FlowerFileRepository::getFlowerList(){
    return flowerList;
}

void FlowerFileRepository::setFlowerList(list<Flower> l){
    flowerList = l;
}

Flower* FlowerFileRepository::findByName(const char* name){
    bool found = false;
    int price;
    list<Flower>::iterator it = flowerList.begin();
    Flower* fp = NULL;
    while ((it != flowerList.end()) && (!found)){
        fp = new Flower(*it);
        if (strcmp(fp->getName(), name) == 0)
            found = true;
        it++;
    }
    if (found)
        return fp;
    else
        return NULL;
}
