#include "Gardener.h"
#include <string>
#include <iostream>

using namespace std;

//Descr: create a gardener 
//In: -
//Out: an empty instance of Gardener
Gardener::Gardener(){
	name = NULL;
}

//Descr: distroy a gardener 
//In: a gardener 
//Out: - (destructor)
Gardener::~Gardener(){
	if (name){
		delete[] name;
		name = NULL;
	}
}

//Descr: create a gardener using info from another gardener
//In: a gardener g
//Out: an instance of Gardener with info from g
Gardener::Gardener(const Gardener &g){
	name = new char[strlen(g.name) + 1];
	strcpy_s(name, strlen(g.name) + 1, g.name);
}

//Descr: create a new Gardener (equal to a given gardener g)
//In: a gardener g
//Out: a new gardener (equal to g)
Gardener& Gardener::operator=(const Gardener &g){
	if (this != &g){
		if (name)
			delete[] name;
		name = new char[strlen(g.name) + 1];
		strcpy_s(name, strlen(g.name) + 1, g.name);
	}
	return *this;
}

//Descr: change the name of a gardener 
//In: a gardener and a name
//Out: the gardener with changed name
void Gardener::setName(char* n){
	if (name)
		delete[] name;
	name = new char[strlen(n) + 1];
	strcpy_s(name, strlen(n) + 1, n);
}

//Descr: access the name of a gardener 
//In: a gardener
//Out: the name
char* Gardener::getName(){
	return name;
}

//Descr: example of a method with an object as param
//In: a gardener and a box b
//Out: -
void Gardener::working(Box &b){
	if (!b.getFull()){
		//do something
		cout << " box is not full" << endl;
	}
	else{
		cout << " box is full" << endl;
	}
}