#include "List.h"

List::List(){
	head = NULL;
}

Node* List::copy(){
	Node* newHead = new Node(head->getInfo(), NULL);
	Node* crt = head->getNext();
	if (crt){
		Node* newCrt = new Node(crt->getInfo(), NULL);
		newHead->setNext(newCrt);
		while (newCrt){
			crt = crt->getNext();
			if(crt){
				Node *newNode = new Node(crt->getInfo(), NULL);
				newCrt->setNext(newNode);
			}
			newCrt = newCrt->getNext();
		}
	}
	return newHead;
}

List::List(List& l){
	head = l.copy();
}

void List::clear(){
	Node* crt;
	while (head){
		crt = head;
		head = head->getNext();
		delete crt;
	}
}
List::~List(){
	clear();
}

List& List::operator=(List& l){
	if (this != &l){
		clear();
		this->head = l.copy();
	}
	return *this;
}

void List::addInfo(TE i){
	Node* n = new Node(i, head);
	head = n;
}

int List::getLength(){
	int n = 0;
	Node* node = head;
	while (node){
		n++;
		node = node->getNext();
	}
	return n;
}

TE List::getElem(int pos){
	int n = 0;
	Node* node = head;
	while ((n < pos) && (node)){
		n++;
		node = node->getNext();
	}
	if (node)
		return node->getInfo();
	else
		return 0;
}

void List::removeElem(TE i){
	if (head->getInfo() == i){
		Node* aux = head;
		head = head->getNext();
		delete aux;
	}
	else{
		Node* node = head;
		while ((node) && (node->getNext()) && (node->getNext()->getInfo() != i) )
			node = node->getNext();
		if (node->getNext()->getInfo() == i){
			Node* aux = node->getNext();
			node->setNext(aux->getNext());
			delete aux;
		}
	}
}