#include "Patient.h"


Patient::Patient(){
	name = NULL;
	address = NULL;
}

Patient::Patient(char* n, char* a){
	name = new char[strlen(n) + 1];
	strcpy_s(name, strlen(n) + 1, n);
	address = new char[strlen(a) + 1];
	strcpy_s(address, strlen(a) + 1, a);
}

Patient::Patient(const Patient &p){
	name = new char[strlen(p.name) + 1];
	strcpy_s(name, strlen(p.name) + 1, p.name);
	address = new char[strlen(p.address) + 1];
	strcpy_s(address, strlen(p.address) + 1, p.address);
}
Patient::~Patient(){
	if (name){
		delete[] name;
		name = NULL;
	}
	if (address){
		delete[] address;
		address = NULL;
	}
}
void Patient::setName(char* n){
	if (name != NULL)
		delete[] name;
	name = new char[strlen(n) + 1];
	strcpy_s(name, strlen(n) +1 , n);
}
void Patient::setAddress(char* a){
	if (address)
		delete[] address;
	address = new char[strlen(a) + 1];
	strcpy_s(address, strlen(a) + 1, a);
}
char* Patient::getName(){
	return name;
}
char* Patient::getAddress(){
	return address;
}
Patient& Patient::operator=(Patient &p){
	if (this != &p){
		setName(p.name);
		setAddress(p.address);
	}
	return *this;
}

bool Patient::operator==(Patient &p){
	return ((strcmp(name,p.name) == 0) && (strcmp(address, p.address) == 0));
}
bool Patient::operator>(Patient &p){
	return strcmp(name,p.name);
}
char* Patient::toString(){
	int l = strlen(name) + 1 + strlen(address) + 1 + 1;
	char* s = new char[l];
	strcpy_s(s, l, name);
	strcat_s(s, l, " ");
	strcat_s(s, l, address);
	strcat_s(s, l, ";");
	return s;
}