#include "mainwindow.h"
#include "ui_mainwindow.h"
#include "Flower.h"

MainWindow::MainWindow(QWidget *parent, FlowerFileRepository* r) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);
    rep = r;
    populateFlowerList();
    connect(ui->flowerListView, SIGNAL(currentItemChanged(QListWidgetItem*,QListWidgetItem*)), this, SLOT(flowerClicked()));
    connect(ui->removeFlower, SIGNAL(clicked()), this, SLOT(removeFlowerClicked()));
}

void MainWindow::populateFlowerList(){
    list<Flower> l = rep->getFlowerList();
    list<Flower>::iterator it = l.begin();
    ui->flowerListView->clear();
    while (it != l.end()){
        QString s = (*it).getName();
        ui->flowerListView->addItem(s);
        it++;
    }
}

MainWindow::~MainWindow()
{
    rep->saveData();
    delete ui;
}

void MainWindow::setRep(FlowerFileRepository* r){
    rep = r;
}

FlowerFileRepository* MainWindow::getRep(){
    return rep;
}

void MainWindow::flowerClicked(){
    if (rep->getFlowerList().size() > 0){
        QString selectedFlower = ui->flowerListView->currentItem()->text();
        Flower* f = rep->findByName(selectedFlower.toLatin1());
        if (f != NULL){
            char* stringPrice = new char[6];
            sprintf(stringPrice, "%d", f->getPrice());
            QString sp(stringPrice);
            ui->flowerText->setText(sp);
        }
    }
}


void MainWindow::removeFlowerClicked(){
    QString selectedFlower = ui->flowerListView->currentItem()->text();
    list<Flower> flowerList = rep->getFlowerList();
    Flower* f = rep->findByName(selectedFlower.toLatin1());
    if (f != NULL){
        flowerList.remove(*f);
        rep->setFlowerList(flowerList);   

        ui->flowerListView->deleteLater();
        ui->flowerListView = new QListWidget(this);
        ui->flowerListView->setGeometry(10, 30, 261, 221);
        ui->flowerListView->show();
        connect(ui->flowerListView, SIGNAL(currentItemChanged(QListWidgetItem*,QListWidgetItem*)), this, SLOT(flowerClicked()));

        ui->flowerText->setText("");
        list<Flower>::iterator it = flowerList.begin();
        while (it != flowerList.end()){
            QString s = (*it).getName();
            ui->flowerListView->addItem(s);
            it++;
        }
    }

}

